package jf04;

import java.util.Arrays;

/**
 *
 * @author Lefteris Moussiades
 */
public class OneDim {

    public static void create() {
        int[] array; // declaration 
        array = new int[3]; //definition
        array[0] = 1;
        array[1] = 3;
        array[2] = 5;
        for (int i = 0; i < array.length; i++) {
            System.out.println("element at " + i + " is " + array[i]);
            array[i] = 5;
        }
    }

    public static void initByConstant() {
        int[] array = {1, 3, 5};
        for (int element : array) {  
            System.out.println("Current Element is " + element);
            element = 9;
        }
        //element=9;
    }

    public static void constantArrayOfStrings() {
        String[] array = {"John", "Mike", "George", "John"};
        System.out.println(array[0] == array[3]);
    }

    public static void arrayOfStrings() {

        String[] array = new String[3];

        array[0] = new String("John");
        array[1] = "John";
        array[2] = "John";

        //array[1] = "Mary";
        System.out.println(array[0] == array[1]);
        System.out.println(array[1] == array[2]);
    }

    public static void copy() {
        char[] copyFrom = {'d', 'e', 'c', 'a', 'f', 'f', 'e',
            'i', 'n', 'a', 't', 'e', 'd'};
        char[] copyTo = new char[7];

        System.arraycopy(copyFrom, 2, copyTo, 0, 7);
        System.out.println(new String(copyTo));
    }

    public static void copyOfRange() {

        char[] copyFrom = {'d', 'e', 'c', 'a', 'f', 'f', 'e',
            'i', 'n', 'a', 't', 'e', 'd'};

        char[] copyTo = Arrays.copyOfRange(copyFrom, 2, 9);

        System.out.println(new String(copyTo));
    }

    public static int[] merge(int[] t1, int[] t2) {
        int[] rVal = new int[t1.length + t2.length];
        System.arraycopy(t1, 0, rVal, 0, t1.length);
        System.arraycopy(t2, 0, rVal, t1.length, t2.length);
        return rVal;
    }

    public static void main(String[] args) {
//        int[] t1 = {1, 2, 3, 4, 5};
//        int[] t2 = {6,7,8};
//        int[] rslt=merge(t1,t2);
//        System.out.println(Arrays.toString(rslt));
        //create();
        //initByConstant();
        //constantArrayOfStrings();
        arrayOfStrings();
        //copy();
        //copyOfRange();
        //for (int i=0; i<10; i++) {
        //System.out.println(i);
        //int j=i+1;
        //System.out.println(j);
        //}
    }
}
